;; Illumination-Sawmill/theme.jl

(let*
    ((bottom-images (list (make-image "b6-.png") (make-image "b6.png")))
     ;; 217x10

     ;; 4x219
     (top-images (list (make-image "b2-.png") (make-image "b2.png")))

     ;; 10x190

     (right-images (list (flip-image-diagonally
			  (copy-image (nth 0 bottom-images)))
			 (flip-image-diagonally
			  (copy-image (nth 1 bottom-images)))))

     ;; 10x190
     (left-images (list (flip-image-diagonally
			 (copy-image (nth 0 bottom-images)))
			(flip-image-diagonally
			 (copy-image (nth 1 bottom-images)))))

     ;; 7x23
     (top-left-images (list (make-image "b1-.png") (make-image "b1.png")))
     (bottom-left-images (list (make-image "b7-.png") (make-image "b7.png")))
     (top-right-images (list (make-image "b3-.png") (make-image "b3.png")))
     (bottom-right-images (list (make-image "b5-.png") (make-image "b5.png")))

     ;; 27x23
     (menu-images (list (make-image "t1-.png") (make-image "t1.png")
			nil (make-image "t1b.png")))

     ;; 150x23
     (title-images (list (set-image-border (make-image "t2-.png") 10 10 0 0)
			 (set-image-border (make-image "t2.png") 10 10 0 0)))

     ;; 23x23
     (iconify-images (list (make-image "t3-.png") (make-image "t3.png")
			   nil (make-image "t3b.png")))

     ;; 23x23
     (maximize-images (list (make-image "t4-.png") (make-image "t4.png")
			    nil (make-image "t4b.png")))

     ;; 23x23
     (close-images (list (make-image "t5-.png") (make-image "t5.png")
			 nil (make-image "t5b.png")))

     (frame `(((background . ,menu-images)
	       (top-edge . -23)
	       (left-edge . -1)
	       (class . menu-button))
	      ((background . ,title-images)
	       (foreground . "black")
	       (text . ,window-name)
	       (x-justify . 10)
	       (y-justify . center)
	       (left-edge . 21)
	       (right-edge . 67)
	       (top-edge . -23)
	       (class . title))
	      ((background . ,iconify-images)
	       (right-edge . 45)
	       (top-edge . -23)
	       (class . iconify-button))
	      ((background . ,maximize-images)
	       (right-edge . 22)
	       (top-edge . -23)
	       (class . maximize-button))
	      ((background . ,close-images)
	       (right-edge . -1)
	       (top-edge . -23)
	       (class . close-button))
	      ((background . ,left-images)
	       (left-edge . -8)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . left-border))
	      ((background . ,right-images)
	       (right-edge . -8)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))
	      ((background . ,top-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (top-edge . -23)
	       (class . top-border))
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -10)
	       (class . bottom-border))
	      ((background . ,top-left-images)
	       (left-edge . -8)
	       (top-edge . -23)
	       (class . top-left-corner))
	      ((background . ,top-right-images)
	       (right-edge . -8)
	       (top-edge . -23)
	       (class . top-right-corner))
	      ((background . ,bottom-left-images)
	       (left-edge . -8)
	       (bottom-edge . -10)
	       (class . bottom-left-corner))
	      ((background . ,bottom-right-images)
	       (right-edge . -8)
	       (bottom-edge . -10)
	       (class . bottom-right-corner))))

     (shaped-frame `(((background . ,menu-images)
		      (top-edge . -23)
		      (left-edge . -1)
		      (class . menu-button))
		     ((background . ,title-images)
		      (foreground . "black")
		      (text . ,window-name)
		      (x-justify . 10)
		      (y-justify . center)
		      (left-edge . 21)
		      (right-edge . 67)
		      (top-edge . -23)
		      (class . title))
		     ((background . ,iconify-images)
		      (right-edge . 45)
		      (top-edge . -23)
		      (class . iconify-button))
		     ((background . ,maximize-images)
		      (right-edge . 22)
		      (top-edge . -23)
		      (class . maximize-button))
		     ((background . ,close-images)
		      (right-edge . -1)
		      (top-edge . -23)
		      (class . close-button))
		     ((background . ,top-images)
		      (left-edge . 0)
		      (right-edge . 0)
		      (top-edge . -23)
		      (class . top-border))
		     ((background . ,bottom-images)
		      (left-edge . 0)
		      (right-edge . 0)
		      (top-edge . -4)
		      (class . bottom-border))
		     ((background . ,top-left-images)
		      (left-edge . -8)
		      (top-edge . -23)
		      (class . top-left-corner))
		     ((background . ,top-right-images)
		      (right-edge . -8)
		      (top-edge . -23)
		      (class . top-right-corner))
		     ((background . ,bottom-left-images)
		      (left-edge . -8)
		      (top-edge . -4)
		      (class . bottom-left-corner))
		     ((background . ,bottom-right-images)
		      (right-edge . -8)
		      (top-edge . -4)
		      (class . bottom-right-corner))))

     (transient-frame `(((background . ,top-images)
			 (left-edge . 0)
			 (right-edge . 0)
			 (top-edge . -4)
			 (class . title))
			((background . ,bottom-images)
			 (left-edge . 0)
			 (right-edge . 0)
			 (bottom-edge . -10)
			 (class . bottom-border))
			((background . ,left-images)
			 (left-edge . -8)
			 (top-edge . -4)
			 (bottom-edge . 0)
			 (class . left-border))
			((background . ,right-images)
			 (right-edge . -8)
			 (top-edge . -4)
			 (bottom-edge . 0)
			 (class . right-border))
			((background . ,bottom-left-images)
			 (left-edge . -8)
			 (bottom-edge . -10)
			 (class . bottom-left-corner))
			((background . ,bottom-right-images)
			 (right-edge . -8)
			 (bottom-edge . -10)
			 (class . bottom-right-corner))))

     (shaped-transient-frame `(((background . ,top-images)
				(left-edge . 0)
				(right-edge . 0)
				(top-edge . -4)
				(class . title))
			       ((background . ,top-left-images)
				(left-edge . -4)
				(top-edge . -4)
				(class . top-left-corner))
			       ((background . ,top-right-images)
				(right-edge . -4)
				(top-edge . -4)
				(class . top-right-corner)))))

  (add-frame-style 'Illumination-Sawmill
		   (lambda (w type)
		     (cond ((eq type 'shaped)
			    shaped-frame)
			   ((eq type 'shaped-transient)
			    shaped-transient-frame)
			   ((eq type 'transient)
			    transient-frame)
			   ((eq type 'unframed)
			    nil-frame)
			   (t
			    frame)))))
